import re

def model(l):
    model=str()
    p=re.compile('\s+cisco')
    for i in l:
        m=p.search(i)
        if m:
            i=' '.join(i.split())
            t=i.split(' ')
            model=t[0]+' '+t[1]+' '+t[2]
    if not model:
        model='unknown'
    return model

def hname(l):
    p=re.compile('^.+[#]')
    for i in l:
        m=p.search(i)
        if m:
            t=i.split('#')
            hname=t[0]
            break
        else:
            hname='unknown'
    return hname

def ipaddr(l):
    p=re.compile('^IPADDR')
    for i in l:
        m=p.search(i)
        if m:
            t=i.split(' ')
    ip=t[1]
    return ip

def temperature(l):
    result=list()
    tmp=str()
    p=re.compile('^\d+\s+.+[(]{1}.+[)]{1}\s+\d{1,3}\s+')
    for i in l:
        m=p.search(i)
        if m:
            i=' '.join(i.split())
            t=i.split(' ')
            if t[-1] !='Ok':
                tmp+=t[0]+' '+t[-1]
    if tmp:
        result.append(tmp)
        result.append('점검필요')
    else:
        result.append('Temperature is Ok')
        result.append('정상')
    return result


def fanstate(l):
    result=list()
    tmp=str()
    p=re.compile('^Fan\d+|^Fan_in')
    for i in l:
        m=p.search(i)
        if m:
            t=' '.join(i.split())
            t=t.split(' ')
            if t[-1].lower() != 'ok':
                tmp+=t[0]+' '+t[-1]+' '
    if tmp:
        result.append(tmp)
        result.append('점검필요')
    else:
        result.append('All Fan is Ok')
        result.append('정상')
    return result

def powersupply(l):
    result=list()
    tmp=str()
    p=re.compile('[0-9]+\sW\s+[0-9]+\sW\s+')
    for i in l:
        m=p.search(i)
        if m:
            i=' '.join(i.split())
            t=i.split(' ')
            if t[-1] != 'Ok' and t[-1] != 'Powered-Up':
                tmp+=t[1]+':'+t[-1]+' '
    if tmp:
        result.append(tmp)
        result.append('점검필요')
    else:
        result.append('All Power is Ok')
        result.append('정상')
    return result

def uptime(l):
    result=list()
    tmp=str()
    p=re.compile('Kernel uptime')
    for i in l:
        m=p.search(i)
        if m:
            i=' '.join(i.split())
            t=i.split(' ')
            tmp=t[3]+' '+t[4]+' '+t[5]+' '+t[6]
    if tmp:
        result.append(tmp)
        result.append('정상')
    else:
        result.append('error')
        result.append('점검필요')

    return result

def cpuutil(l):
    result=list()
    tmp=str()
    util=str()
    p=re.compile('^CPU states')
    for i in l:
        m=p.search(i)
        if m:
            i=' '.join(i.split())
            t=i.split(' ')
            tmp+=t[7]+t[8]
            util=' '.join(t[7].split('%'))   
    if float(util) < 50 :
        result.append(tmp)
        result.append('점검필요')
    else:
        result.append(tmp)
        result.append('정상')
        
    if not tmp:
        result.append('error')
        result='점검필요'
    return result


def memutil(l):
    result=list()
    tmp=str()
    p=re.compile('^Memory usage')
    for i in l:
        m=p.search(i)
        if m:
            i=' '.join(i.split())
            t=i.split(' ')
            t[6]=' '.join(t[6].split('K'))
            t[2]=' '.join(t[2].split('K'))
            free=int(t[6])/int(t[2])*100
            tmp='%2.1f' %(free)
            tmp+='% Free'
    if free < 50:
        result.append(tmp)
        result.append('점검필요')
    if not tmp:
        result.append('error')
        result.append('점검필요')
    else:
        result.append(tmp)
        result.append('정상')
    return result

def module(l):
    result=list()
    tmp=str()
    p=re.compile('^\d{1,2}\s+\d{1,2}\s+.+\s(Ethernet|Supervisor)\sModule')
    for i in l:
        m=p.search(i)
        if m:
            i=' '.join(i.split())
            t=i.split(' ')
            if t[-1] == 'ok':
                tmp+=t[0]+' '+t[-1]+','
            elif t[-1]=='*':
                tmp+=t[0]+' '+t[-2]+','
            elif t[-1]=='ha-standby':
                tmp+=t[0]+' '+t[-1]+','
            else:
                tmp+=t[0]+' '+t[-1]+' check,'

    result.append(tmp)
    p=re.compile('check')
    m=p.search(tmp)
    if m:
        result.append('점검필요')
    else:
        result.append('정상')
        
    if not tmp:
        result.append('error')
        result.append('점검필요')
    return result

def iface(l):
    result=list()
    tmp=str()
    p=re.compile('^Eth|^Po\d+|^Vlan')
    con=0
    cnt=0
    etc=0
    err=0
    for i in l:
        m=p.search(i)
        if m:
            cnt+=1
            i=' '.join(i.split())
            t=i.split(' ')
            if t[2]=='connected':
                con+=1
            elif t[2]=='disabled' or t[2]=='down' or t[2]=='sfpAbsent' or t[2]=='xcvrAbsen' or t[2]=='connection' :
                etc+=1
            elif t[2]=='err-disabled':
                err+=1
            else:
                etc+=1
    tmp='Total:%d, connected:%d, err-disabled:%d, etc:%d' %(cnt, con, err, etc)
    result.append(tmp)
    if err!=0:
        result.append('점검필요')
    else:
        result.append('정상')
    return result

def ifaceerr(l):
    result=list()
    fname=list()
    tmp=str()
    p=re.compile('^Ethernet\d+[/]{1}\d+\s+is')
    for i in range(0,len(l)):
        m=p.search(l[i])
        if m:
            extract=list()
            extract.append(l[i])
            extract.append(l[i+3])
            extract.append(l[i+4])
            err=iserror(extract)
            if err!='None':
                fname=extract[0].split(' ')
                tmp+=fname[0]+':'+err+' '
    if tmp:
        result.append(tmp)
        result.append('점검필요')
    else:
        result.append('All interface is ok')
        result.append('정상')
    return result

def iserror(extract):
    result=str()
    err1=' '.join(extract[1].split())
    err2=' '.join(extract[2].split())
    err=err1+' '+err2
    tmp=err.split(' ')
    if tmp[0]!='0':
       result+=tmp[0]+tmp[1]+tmp[2] 
    elif tmp[3]!='0':
        result+=' '+tmp[3]+tmp[4]+tmp[5]
    elif tmp[6]!='0':
        result+=' '+tmp[6]+tmp[7]
    elif tmp[8]!='0':
        result+=' '+tmp[8]+tmp[9]
    elif tmp[10]!='0':
        result+=' '+tmp[10]+tmp[11]
    elif tmp[12]!='0':
        result+=' '+tmp[12]+tmp[13]+tmp[14]
    elif tmp[15]!='0':
        result+=' '+tmp[15]+tmp[16]
    elif tmp[17]!='0':
        result+=' '+tmp[17]+tmp[18]+tmp[19]
    else:
        result='None'
    return result
        
def chkroute(l):
    result=list()
    tmp=str()
    p=re.compile('^Total.+routes')
    for i in l:
        m=p.search(i)
        if m:
            tmp=i

    if tmp:
        result.append(tmp)
        result.append('정상')
    else:
        result.append('error')
        result.append('점검필요')
    return result

def chklog(l):
    result=list()
    tmp=str()
    p=re.compile('BAD_ID|BUFFERMANAGER|CHASSIS|ERROR|FAILED|WARNING|ERR|SW_DAI|SUPERVISOR|STORE')
    for i in l:
        m=p.search(i)
        if m:
            tmp+=i+'\n'

    if tmp:
        result.append(tmp)
        result.append('점검필요')
    else:
        result.append('No error')
        result.append('정상')
        
    return result
            

    
if __name__=='__main__':
    f=open('raw.txt', 'r')
    s=f.read()
    f.close()
    l=s.split('\n')

    print(model(l))
    print(hname(l))
    print(temperature(l))
    print(fanstate(l))
    print(powersupply(l))
    print(uptime(l))
    print(cpuutil(l))
    print(memutil(l))
    print(module(l))
    print(iface(l))
    print(ifaceerr(l))
    print(chkroute(l))
    print(chklog(l))
